#include "stdafx.h"

CGraph * g_pGraphProp;

//---------------------------------------------------------------------------------
LRESULT CALLBACK GraphProperties(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam){
	static HBRUSH g_brButton = NULL;
	char buf[256];
	switch (message){
		case WM_INITDIALOG:
			//-- Main Title 
			SetWindowText( GetDlgItem( hDlg, IDC_EDTTITLE ),  g_pGraphProp->m_cTitle.ConstBuffer() );			

			//-- Y axis
			SetWindowText( GetDlgItem( hDlg, IDC_EDTYTITLE ),  g_pGraphProp->m_cYTitle.ConstBuffer() );			

			sprintf( buf, "%f", g_pGraphProp->m_dYLabelMin );	
			SetWindowText( GetDlgItem( hDlg, IDC_EDTYLABELMIN ), buf );			
			sprintf( buf, "%f", g_pGraphProp->m_dYLabelSep );	
			SetWindowText( GetDlgItem( hDlg, IDC_EDTYLABELSEP ), buf );			
			sprintf( buf, "%f", g_pGraphProp->m_dYMin );		
			SetWindowText( GetDlgItem( hDlg, IDC_EDTYMIN ), buf );			
			sprintf( buf, "%f", g_pGraphProp->m_dYMax );		
			SetWindowText( GetDlgItem( hDlg, IDC_EDTYMAX ), buf );			

			//-- X axis
			SetWindowText( GetDlgItem( hDlg, IDC_EDTXTITLE ),  g_pGraphProp->m_cXTitle.ConstBuffer() );			

			sprintf( buf, "%f", g_pGraphProp->m_dXLabelMin );	
			SetWindowText( GetDlgItem( hDlg, IDC_EDTXLABELMIN ), buf );			
			sprintf( buf, "%f", g_pGraphProp->m_dXLabelSep );	
			SetWindowText( GetDlgItem( hDlg, IDC_EDTXLABELSEP ), buf );			
			sprintf( buf, "%f", g_pGraphProp->m_dXMin );		
			SetWindowText( GetDlgItem( hDlg, IDC_EDTXMIN ), buf );			
			sprintf( buf, "%f", g_pGraphProp->m_dXMax );		
			SetWindowText( GetDlgItem( hDlg, IDC_EDTXMAX ), buf );			

			//-- Colors 
			if( g_brButton != NULL ) 
				DeleteObject(g_brButton);
			g_brButton = NULL;
			return TRUE;

		case WM_COMMAND: {
			int wmId = LOWORD(wParam); 
			int iColor=0;
			switch( wmId ) { 
				case IDC_BTNCOLOR3 : 
					++iColor;
				case IDC_BTNCOLOR2 : 
					++iColor;
				case IDC_BTNCOLOR1 : 
					COLORREF acrTemp[16];
					for( int i=0; i<16; ++i ) 
						acrTemp[i]=RGB(128,128,128);

					CHOOSECOLOR cc;
					ZeroMemory(&cc, sizeof(cc));
					cc.lStructSize = sizeof(cc);
					cc.hwndOwner = hDlg;
					cc.lpCustColors = acrTemp;	
					cc.rgbResult = ( iColor==0 ? g_pGraphProp->m_crFill : iColor==1 ? g_pGraphProp->m_crLine : g_pGraphProp->m_crCurve );
					cc.Flags = CC_FULLOPEN | CC_RGBINIT;	// CC_FULLOPEN CC_ANYCOLOR | 

					if( ChooseColor(&cc) ) {
						if( iColor==0 ) 
							g_pGraphProp->m_crFill=cc.rgbResult;
						else if( iColor==1 ) 
							g_pGraphProp->m_crLine=cc.rgbResult;
						else if( iColor==2 ) 
							g_pGraphProp->m_crCurve=cc.rgbResult;;
						}
					InvalidateRect( hDlg, NULL, false );
					break;

				case IDOK : 
					//-- Main Title 
					GetWindowText( GetDlgItem( hDlg, IDC_EDTTITLE ),  buf, 256 );
					g_pGraphProp->m_cTitle = buf;

					//-- Y axis
					GetWindowText( GetDlgItem( hDlg, IDC_EDTYTITLE ), buf, 256 );
					g_pGraphProp->m_cYTitle = buf;
					
					GetWindowText( GetDlgItem( hDlg, IDC_EDTYLABELMIN ), buf, 256 );			
					g_pGraphProp->m_dYLabelMin = atof( buf );
					GetWindowText( GetDlgItem( hDlg, IDC_EDTYLABELSEP ), buf, 256 );			
					g_pGraphProp->m_dYLabelSep = atof( buf );
					GetWindowText( GetDlgItem( hDlg, IDC_EDTYMIN ), buf, 256 );			
					g_pGraphProp->m_dYMin = atof( buf );
					GetWindowText( GetDlgItem( hDlg, IDC_EDTYMAX ), buf, 256 );			
					g_pGraphProp->m_dYMax = atof( buf );

					//-- X axis
					GetWindowText( GetDlgItem( hDlg, IDC_EDTXTITLE ),  buf, 256 );
					g_pGraphProp->m_cXTitle = buf;

					GetWindowText( GetDlgItem( hDlg, IDC_EDTXLABELMIN ), buf, 256 );			
					g_pGraphProp->m_dXLabelMin = atof( buf );
					GetWindowText( GetDlgItem( hDlg, IDC_EDTXLABELSEP ), buf, 256 );			
					g_pGraphProp->m_dXLabelSep = atof( buf );
					GetWindowText( GetDlgItem( hDlg, IDC_EDTXMIN ), buf, 256 );			
					g_pGraphProp->m_dXMin = atof( buf );
					GetWindowText( GetDlgItem( hDlg, IDC_EDTXMAX ), buf, 256 );			
					g_pGraphProp->m_dXMax = atof( buf );
					// no break
					
				case IDCANCEL : 
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;
					break;
				}
			break;
			}

		case WM_CTLCOLORBTN : { 
			int wmId = GetDlgCtrlID( (HWND)lParam );
			if( wmId==IDC_BTNCOLOR1 || wmId==IDC_BTNCOLOR2 || wmId==IDC_BTNCOLOR3 ) { 
				if( g_brButton != NULL ) 
					DeleteObject(g_brButton);
				COLORREF cr = ( wmId==IDC_BTNCOLOR1 ? g_pGraphProp->m_crFill : wmId==IDC_BTNCOLOR2 ? g_pGraphProp->m_crLine : g_pGraphProp->m_crCurve );
				g_brButton=CreateSolidBrush( cr );
				return (BOOL)(g_brButton);
				}
			return FALSE;
			}
		}
		
	return FALSE;
	}

bool GetGraphProperties( HWND hWndOwner, CGraph * pGraph ) {
	g_pGraphProp = pGraph;
	return IDOK == DialogBox( GetInstance( ), (LPCTSTR)IDD_DLG_GRAPHPROPERTIES, hWndOwner, (DLGPROC)GraphProperties) ;
	}







